SOURCES=" factory.js uitypesdef.js utils.js i18n.js widget.js \
	bricks.js image.js \
	jsoncall.js myoperator.js layout.js scroll.js menu.js modal.js \
	markdown_viewer.js video.js audio.js toolbar.js tab.js \
	input.js registerfunction.js button.js accordion.js \
	tree.js multiple_state_image.js form.js message.js \
	paging.js datagrid.js dataviewer.js iframe.js \
	miniform.js wterm.js dynamicaccordion.js "
echo ${SOURCES}
cat ${SOURCES} > ../dist/bricks.js
# uglifyjs --compress --mangle -- ../dist/bricks.js > ../dist/bricks.min.js
if [ ! -d ../dist/css ];then
	rm -rf ../dist/css
	mkdir ../dist/css
fi
if [ ! -d ../dist/3parties ];then
	rm -rf ../dist/3parties
	mkdir ../dist/3parties
fi
if [ ! -d ../dist/examples ];then
	rm -rf ../dist/examples
	mkdir ../dist/examples
fi
if [ ! -d ../dist/docs ];then
	rm -rf ../dist/docs
	mkdir ../dist/docs
fi
if [ ! -d ../dist/imgs ];then
	rm -rf ../dist/imgs
	mkdir ../dist/imgs
fi
cp -a css/* ../dist/css
cp -a imgs/* ../dist/imgs
cp -a ../examples/* ../dist/examples
cp -a ../3parties/* ../dist/3parties
cp -a ../docs/* ../dist/docs
cp *.tmpl ../dist
echo "Finished ..."
