var bricks = window.bricks || {};
bricks.Image = class oops extends bricks.JsWidget {
	/* 
	{
		url:
		height:
		width:
	}
	*/
	constructor(opts){
		super(opts);
		this.opts = opts;
		this.options_parse();
	}
	create(){
		this.dom_element = document.createElement('img');
	}
	options_parse(){
		if (this.opts.hasOwnProperty('url')){
			this.set_url(this.opts.url);
		}
		if (this.opts.hasOwnProperty('width')){
			this.width = this.opts.width;
			this.dom_element.style.width = this.width;
		}
		if (this.opts.hasOwnProperty('height')){
			this.height = this.opts.height;
			this.dom_element.style.height = this.height;
		}
	}
	set_url(url){
		this.url = url;
		this.dom_element.src = url;
	}
}

bricks.Icon = class oops extends bricks.Image {
	constructor(opts){
		var rate = opts.rate || 1;
		var siz = bricks.app.charsize * rate + 'px';
		opts.width = siz;
		opts.height = siz;
		super(opts);
		this.rate = rate;
		this.ctype = 'text';
		this.sizable();
		this.set_fontsize();
	}
	change_fontsize(ts){
		var siz = bricks.app.charsize * this.rate + 'px';
		this.set_width(siz);
		this.set_height(siz);
	}
	set_fontsize(){
		var siz = bricks.app.charsize * this.rate + 'px';
		this.set_width(siz);
		this.set_height(siz);
	}
	set_width(siz){
		this.dom_element.width = siz;
	}
	set_height(siz){
		this.dom_element.height = siz;
	}
}

bricks.BlankIcon = class oops extends bricks.JsWidget {
	constructor(opts){
		super(opts);
		this.rate = opts.rate || 1;
		this.ctype = 'text';
		this.sizable();
		this.set_fontsize();
	}
	change_fontsize(ts){
		var siz = bricks.app.charsize * this.rate + 'px';
		this.set_width(siz);
		this.set_height(siz);
	}
	set_fontsize(){
		var siz = bricks.app.charsize * this.rate + 'px';
		this.set_width(siz);
		this.set_height(siz);
	}
	set_width(siz){
		this.dom_element.width = siz;
		this.dom_element.style.width = siz;
	}
	set_height(siz){
		this.dom_element.height = siz;
		this.dom_element.style.height = siz;
	}
}

bricks.Factory.register('Image', bricks.Image);
bricks.Factory.register('Icon', bricks.Icon);
bricks.Factory.register('BlankIcon', bricks.BlankIcon);
